<?php
// +----------------------------------------------------------------------
// 文件及文件夹处理类
// +----------------------------------------------------------------------



class Xzip{
    
    function unZipFile($zipFilePath, $directoryPath, $fileExtensionArray = null) {

        if (!file_exists($zipFilePath)) {
            return false;
        }

        if (!is_dir($directoryPath)) {
            
            // 解压后是不允许执行的,但是任何人可以读写,方便处理
            if (!mkdir($directoryPath, 0666, true)) {
                return false;
            }
        }

        $resource = zip_open($zipFilePath);

        // 其他类型的文件伪装成zip文件时出现此种情况
        if (is_numeric($resource)) {
            return false;
        }

        while ($dir_resource = zip_read($resource)) {
            if (!zip_entry_open($resource, $dir_resource)) {
                continue;
            }

            $file_name = $directoryPath . zip_entry_name($dir_resource);
            $file_path = substr($file_name, 0, strrpos($file_name, '/'));

            if (!is_dir($file_path)) {
                if (!mkdir($file_path, 0666, true)) {
                    return false;
                }
            }

            if (is_dir($file_name)) {
                zip_entry_close($dir_resource);
                continue;
            }

            if (isset($fileExtensionArray) && count($fileExtensionArray) > 0) {
                if (!in_array(pathinfo($file_name, PATHINFO_EXTENSION), $fileExtensionArray)) {
                    continue;
                }
            }

            $file_size = zip_entry_filesize($dir_resource);
            $file_content = zip_entry_read($dir_resource, $file_size);
            file_put_contents($file_name, $file_content);

            zip_entry_close($dir_resource);
        }
        zip_close($resource);
        return true;
    }
}